! Посчитать определённый интеграл от произвольной функции
! на произвольном отрезке.
! Контрольная №1, Кремер Илья | http://kremer.pro/blog/?post_type=post&p=35

program main
	implicit none
	include "omp_lib.h"

	double precision func
	integer intervals
	double precision a, b, h, s
	integer i
	double precision start_time

	write (*, '(a)', advance='no'), "Нижняя  граница (a): "
	read *, a
	write (*, '(a)', advance='no'), "Верхняя граница (b): "
	read *, b
	write (*, '(a)', advance='no'), "Интервалов:          "
	read *, intervals

	start_time = omp_get_wtime()
	s = 0
	h = (b - a) / intervals
!$omp parallel num_threads(8) firstprivate(a, b, h)
!$omp do reduction (+ : s)
	do i = 0, intervals - 1
		s = s + h * ((func(a + i * h) + func(a + (i + 1) * h))/2.0)
	enddo
!$omp end parallel

	print 10, omp_get_wtime() - start_time, "секунд затрачено"
10	format (/f8.4, 4x, a/)
	print *, "Интеграл равен:"
	print *, s
end program

double precision function func(x)
	double precision x
	func = sin(x * x) + 5
end function
