! Посчитать определённый интеграл от произвольной функции
! на произвольном отрезке.
! Контрольная №1, Кремер Илья | http://kremer.pro/blog/?post_type=post&p=35

program main
	implicit none
	include "omp_lib.h"

	double precision func
	integer intervals
	double precision a, b, h, s, x1, x2
	integer i
	double precision start_time

	write (*, '(a)', advance='no'), "Нижняя  граница (a): "
	read *, a
	write (*, '(a)', advance='no'), "Верхняя граница (b): "
	read *, b
	write (*, '(a)', advance='no'), "Интервалов:          "
	read *, intervals

	start_time = omp_get_wtime()
	h = (b - a) / intervals
	s = 0
	x1 = a; x2 = a + h
	do i = 1, intervals
		s = s + h * ((func(x2) + func(x1))/2.0)
		x1 = x1 + h
		x2 = x2 + h
	enddo

	print 10, omp_get_wtime() - start_time, "секунд затрачено"
10	format (/f8.4, 4x, a/)
	print *, "Интеграл равен:"
	print *, s
end program

double precision function func(x)
	double precision x
	func = sin(x * x) + 5
end function
